unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, fgl, Unit2, StdCtrls;

type

  { TTestClass }

  TTestClass = class(IDescribable)
  private
    FID: Integer;
    FDescription: String;
  public
    function getID: Integer;
    function getDescription: String;
    procedure setID(AValue: Integer);
    procedure setDescription(const AValue: String);
  end;

  TTestList = specialize TFPGObjectList<TTestClass>;

  { TForm1 }

  TForm1 = class(TForm, IDescribableListHanlder)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FList: TTestList;
  public
    function GetCount: Integer;
    function GetItem(AIndex: Integer): IDescribable;
    function createItem: Integer;
    procedure deleteItem(AIndex: Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FList:=TTestList.Create(true);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form2.ListHanlder:=Self;
  Form2.ShowModal;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FList.Free;
end;

function TForm1.GetCount: Integer;
begin
  Result:=FList.Count;
end;

function TForm1.GetItem(AIndex: Integer): IDescribable;
begin
  Result:=FList[AIndex];
end;

function TForm1.createItem: Integer;
begin
  Result:=FList.Add(TTestClass.Create);
end;

procedure TForm1.deleteItem(AIndex: Integer);
begin
  FList.Delete(AIndex);
end;

{ TTestClass }

function TTestClass.getID: Integer;
begin
  Result:=FID;
end;

function TTestClass.getDescription: String;
begin
  Result:=FDescription;
end;

procedure TTestClass.setID(AValue: Integer);
begin
  FID:=AValue;
end;

procedure TTestClass.setDescription(const AValue: String);
begin
  FDescription:=AValue;
end;

end.

