unit Unit2;

{$mode objfpc}{$H+}
{$Interfaces CORBA}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Buttons;

type
  IDescribable = interface
    function getID: Integer;
    function getDescription: String;
    procedure setID(AValue: Integer);
    procedure setDescription(const AValue: String);
  end;

  IDescribableListHanlder = interface
    function GetCount: Integer;
    function GetItem(AIndex: Integer): IDescribable;
    function createItem: Integer;
    procedure deleteItem(AIndex: Integer);
  end;

  { TForm2 }

  TForm2 = class(TForm)
    BitBtn1: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FListHandler: IDescribableListHanlder;
  public
    property ListHanlder: IDescribableListHanlder read FListHandler write FListHandler;
  end;

var
  Form2: TForm2;

implementation

{$R *.lfm}

{ TForm2 }

procedure TForm2.FormShow(Sender: TObject);
begin

end;

procedure TForm2.BitBtn1Click(Sender: TObject);
var
  i: Integer;
begin
  ListBox1.Items.BeginUpdate;
  try
    ListBox1.Clear;
    for i:=0 to FListHandler.GetCount-1 do
    begin
      ListBox1.Items.Add(FListHandler.GetItem(i).getDescription);
    end;
  finally
    ListBox1.Items.EndUpdate;
  end;
end;

procedure TForm2.Button1Click(Sender: TObject);
var
  Itm: Integer;
begin
  Itm := FListHandler.createItem;
  ListBox1.Items.Insert(itm, FListHandler.GetItem(itm).getDescription);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  FListHandler.deleteItem(ListBox1.ItemIndex);
  ListBox1.Items.Delete(ListBox1.ItemIndex);
end;

procedure TForm2.Button3Click(Sender: TObject);
function newText: String;
var
  i: Integer;
begin
  SetLength(Result, Random(5) + 5);
  for i:=1 to Result.Length do
    Result[i] := chr(ord('A') + random(26));
end;

begin
  ListBox1.Items[ListBox1.ItemIndex] := newText;
end;

end.

